/*

Copyright (C) 2002-2003, Jeffrey D. Argast.

The authors make NO WARRANTY or representation, either express or implied,
with respect to this software, its quality, accuracy, merchantability, or
fitness for a particular purpose.  This software is provided "AS IS", and you,
its user, assume the entire risk as to its quality and accuracy.

Permission is hereby granted to use, copy, modify, and distribute this
software or portions thereof for any purpose, without fee, subject to these
conditions:

(1) If any part of the source code is distributed, then this
statement must be included, with this copyright and no-warranty notice
unaltered.

(2) Permission for use of this software is granted only if the user accepts
full responsibility for any undesirable consequences; the authors accept
NO LIABILITY for damages of any kind.

*/

#import "PerforceActionPrint.h"


@implementation PerforceActionPrint

+ (void) defaultRunFor:(id)owner
		 selector:(SEL)aSelector
		 withPath:(NSString*)filePath
		 outputPath:(NSString*)outputPath
{
	PerforceActionPrint* action = [[[PerforceActionPrint alloc] init] autorelease];
	
	[action runFor:owner selector:aSelector withPath:filePath outputPath:outputPath];
}

- (void) dealloc
{
	[fOwner release];
	[fOutputPath release];
	
	[super dealloc];
}

- (void) runFor:(id)owner 
		 selector:(SEL)aSelector 
		 withPath:(NSString*)filePath
		 outputPath:(NSString*)outputPath
{
    NSMutableArray* commandAndArgs = [[[NSMutableArray alloc] init] autorelease];
	
	fOwner    = [owner retain];
	fSelector = aSelector;

	fOutputPath = [outputPath retain];
	
	[commandAndArgs addObject:@"print"];
	
	//[commandAndArgs addObject:@"-o"];

	//[commandAndArgs addObject:outputPath];

	[commandAndArgs addObject:@"-q"];

	[commandAndArgs addObject:filePath];

    
    [self runAction:commandAndArgs stdInString:nil readToEOF:YES];

}

- (void) processOutput: (NSString*) perforceOutput
{
	NSFileManager* fileManager = [NSFileManager defaultManager];
	NSData* fileContents = [perforceOutput dataUsingEncoding:NSASCIIStringEncoding allowLossyConversion:NO];
	
	[fileManager createFileAtPath:fOutputPath contents:fileContents attributes:nil];
}

- (NSString*) getOutputPath
{
	return fOutputPath;
}

@end
